

//	This source and fast string search method apply to GNU General Public License. 
//			Copyright (C) 2001-2015 Jasenko Dzinleski 

//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 

//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

//

//	mGrep4_137 written by Dzinleski Jasenko July , 2012 - April , 2015



#include 	<stdio.h>
#include 	<stdlib.h>
#include 	<string.h>
#include 	<math.h>
#include 	<errno.h>
#include 	<dirent.h>

#define	cl	1000

char		v_ext[256];	int	vexti=0;
FILE		*f1,*f2,*f3,*f5;

char		infn[cl];
int 		a1[cl],a2[cl],a3[cl],a4[cl],a5[cl],a6[cl],a7[cl],a8[cl],a9[cl];
int 		a10[cl],a11[cl],a12[cl],a13[cl],a14[cl],a15[cl],a16[cl],a17[cl];

int		ba16[16][16][16][16][2];
int		ba16i=0;
char		ss[cl];
char 		sa1[cl];
long		lac=0;
long		lbc=0;

int 		df=0;
int		ha[cl][6],hai=0;

char		c_l[256]="{[--][++]}{[hh][ll][ee][ss][??][dd][xx]}{[AZ][az][09][__][  ][..][\'\'][""][&&][||][//][\\\\][::][**]}";
int		occ=0;
	
//--------------------------------------------------------------
#ifdef _WINDOWS_

	#include 	<dir.h>
	#include 	<sys/stat.h>

	#define		os	1

	DIR			*dirl;	

	int p_d_(char cmd[256],char lx[256])
	{

		int		i,j,k,l;
		int		fbyte;

		char		dn[256];
		char		fn[256];
		char		ll[256];
		char		st[256];
	
		char		cmd1[256]="dir/s/b "; 
		char		cmd2[256]=" > mls_o1.mar ";
		char		cmd3[256];
	
		for(i=0;i<256;++i){cmd3[i]='\0';}
		l=0;for(i=0;i<strlen(cmd1);++i){cmd3[l]=cmd1[i];++l;}
		for(i=0;i<strlen(cmd);++i){cmd3[l]=cmd[i];++l;}
		for(i=0;i<strlen(cmd2);++i){cmd3[l]=cmd2[i];++l;}
	
	if(system(NULL))
	{
	
		system(cmd3);

		f1=fopen("mls_o1.mar","rb");
		f2=fopen("mls_o2.mar","w");
		fbyte=getc(f1);
		while(!feof(f1))
		{

			for(i=0;i<256;++i){ll[i]='\0';}
			l=0;while(fbyte!=13&&fbyte!=10){ll[l]=fbyte;++l;fbyte=getc(f1);}
			while(fbyte==13||fbyte==10){fbyte=getc(f1);}

			k=0;
			for(i=-1+strlen(lx);i>=0;--i)
			{
				if(lx[i]==ll[(-1+l)-k]){++k;if(k==strlen(lx)&&ll[(-1+l)-(k+1)]=='.'){break;}}else{break;}		
			}
			if(k==strlen(lx))
			{
				//printf("%s\n",ll);
				for(i=0;i<strlen(dn);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",dn[i]);}}
				for(i=0;i<strlen(ll);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",ll[i]);}}fprintf(f2,"%c%c",(char)13,(char)10);
			}
			
		}
		fclose(f1);
		fclose(f2);

	}else{return(0);}

	return(0);
	}

//--------------------------------------------------------------	
#else
//--------------------------------------------------------------
	#include 	<unistd.h>
	#include 	<wait.h>
	#ifndef 	__int64
	typedef long long __int64 ;
	#endif

	#define		os	2

	int p_1_(char *ar[],char ofn[256])
	{

		int 	i,j,k,l;
		int 	outf[2];
		int	status;

//printf("%s ",ar[0]);
//printf("%s ",ar[1]);
//printf("%s ",ar[2]);
//printf("%s ",ar[3]);
//printf("%s ",ar[4]);

		pipe(outf);
		pid_t pid=fork();
		if(pid==0)
		{
			//dup2(0,fileno(stdout));   //Console
			dup2(outf[1],fileno(stdout));
			if((status=execvp(ar[0],ar))<0){while(wait(&status)!= pid);}
		}

		if(pid==0){return(1);}else{

			close(outf[1]);
			dup2(outf[0],fileno(stdin));
	
			FILE *f=fdopen(outf[0],"rt");
			char buffer[32];
			FILE *o=fopen(ofn,"w");

			while(!feof(f)){fgets(buffer,32,f);fprintf(o,"%s",buffer);/*printf("%s",buffer);*/}
			fclose(o);

		}
		return(0);
	}

	int p_d_(char cmd__[256],char lx[256])
	{
	
	int		i,j,k,l;
	int		fbyte;

	char		dn[256];
	char		fn[256];
	char		ll[256];
	char		st[256];
		
	char		cmd_1[256]="ls";
	char		cmd_2[256]="--group-directories-first";
	char		cmd_3[256]="-1";
	char		cmd_4[256]="-R";

	char		*cmd_[6];
	static char 	*ar[]={"ls","--group-directories-first","-1","-R"};

	cmd_[0]=cmd_1;
	cmd_[1]=cmd_2;
	cmd_[2]=cmd_3;
	cmd_[3]=cmd_4;
	cmd_[4]=cmd__;
	cmd_[5]=NULL;

	//printf("%s %s\n",cmd__,lx);

	if(0!=p_1_(cmd_,"mls_o1.mar")){return(0);}
		
	FILE *f1=fopen("mls_o1.mar","rb");
	FILE *f2=fopen("mls_o2.mar","wb");
	for(j=0;j<256;++j){dn[j]='\0';}
	fbyte=getc(f1);
	while(!feof(f1))
	{

		for(i=0;i<256;++i){ll[i]='\0';}
		l=0;while(fbyte!=13&&fbyte!=10&&!feof(f1)){ll[l]=fbyte;++l;fbyte=getc(f1);}
		while(fbyte==13||fbyte==10&&!feof(f1)){fbyte=getc(f1);}

		if((ll[0]=='/')&&(ll[-1+l]==':'))
		{
			for(j=0;j<256;++j){dn[j]='\0';}
			j=0;for(i=0;i<(-1+l);++i){dn[j]=ll[i];++j;}
			dn[j]='/';++j;dn[j]='\0';
			//printf("%s\n",dn);
		}else{
			k=0;
			for(i=-1+strlen(lx);i>=0;--i)
			{
				if(lx[i]==ll[(-1+l)-k]){++k;if(k==strlen(lx)&&ll[(-1+l)-(k+1)]=='.'){break;}}else{break;}
			}
			if(k==strlen(lx))
			{
				//printf("%s\n",ll);
				for(i=0;i<strlen(dn);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",dn[i]);}}
				for(i=0;i<strlen(ll);++i){if(dn[i]!=10&&dn[i]!=13){fprintf(f2,"%c",ll[i]);}}
				fprintf(f2,"%c%c",(char)13,(char)10);
			}
		}
	}
	fclose(f1);
	fclose(f2);
	return(0);
	}

#endif
//--------------------------------------------------------------

int	c_p(char cl_a[256],int ci,int tf,char r_a[256])
{
	int	a,b,c,d=0;
	
	for(a=0;a<256;++a){r_a[a]='\0';}
	if(tf)
	{
		for(a=0;a<strlen(c_l);++a){
			if(cl_a[a]=='{'){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]=='}'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}else{
		for(a=0;a<strlen(cl_a);++a){
			if(cl_a[a]=='['){++d;for(b=a+1;b<strlen(cl_a);++b){if(cl_a[b]==']'){if(d==ci){break;}}}}
			if(b!=strlen(cl_a)){break;}
		}
	}

	d=0;for(c=a+1;c<b;++c){r_a[d]=cl_a[c];++d;if(df){printf("%c",cl_a[c]);}}

	return(0);

}

int	p_1(char sa[cl],int sf)
{

	int	i=0,j,k,l,lsa=strlen(sa),hc=0;
	int	b1,b2,b3,b4;

	//if(lsa==568){df=1;}else{df=0;}

	j=0;
	for(i=0;i<lsa;++i){a1[j]=(int)sa[i];++j;}

	j=0;
	for(i=1;i<lsa;++i){a2[j]=a1[i];++j;}
	for(i=0;i<1;++i){a2[j]=a1[i];++j;}

	if(lsa>=2)
	{
		j=0;
		for(i=2;i<lsa;++i){a3[j]=a1[i];++j;}
		for(i=0;i<2;++i){a3[j]=a1[i];++j;}
	}
	if(lsa>=3)
	{
		j=0;
		for(i=3;i<lsa;++i){a4[j]=a1[i];++j;}
		for(i=0;i<3;++i){a4[j]=a1[i];++j;}
	}
	if(lsa>=4)
	{
		j=0;
		for(i=4;i<lsa;++i){a5[j]=a1[i];++j;}
		for(i=0;i<4;++i){a5[j]=a1[i];++j;}
	}
	if(lsa>=5)
	{
		j=0;
		for(i=5;i<lsa;++i){a6[j]=a1[i];++j;}
		for(i=0;i<5;++i){a6[j]=a1[i];++j;}
	}
	if(lsa>=6)
	{
		j=0;
		for(i=6;i<lsa;++i){a7[j]=a1[i];++j;}
		for(i=0;i<6;++i){a7[j]=a1[i];++j;}
	}
	if(lsa>=7)
	{
		j=0;
		for(i=7;i<lsa;++i){a8[j]=a1[i];++j;}
		for(i=0;i<7;++i){a8[j]=a1[i];++j;}
	}
	if(lsa>=8)
	{
		j=0;
		for(i=8;i<lsa;++i){a9[j]=a1[i];++j;}
		for(i=0;i<8;++i){a9[j]=a1[i];++j;}
	}
	if(lsa>=9)
	{
		j=0;
		for(i=9;i<lsa;++i){a10[j]=a1[i];++j;}
		for(i=0;i<9;++i){a10[j]=a1[i];++j;}
	}
	if(lsa>=10)
	{
		j=0;
		for(i=10;i<lsa;++i){a11[j]=a1[i];++j;}
		for(i=0;i<10;++i){a11[j]=a1[i];++j;}
	}
	if(lsa>=11)
	{
		j=0;
		for(i=11;i<lsa;++i){a12[j]=a1[i];++j;}
		for(i=0;i<11;++i){a12[j]=a1[i];++j;}
	}
	if(lsa>=12)
	{
		j=0;
		for(i=12;i<lsa;++i){a13[j]=a1[i];++j;}
		for(i=0;i<12;++i){a13[j]=a1[i];++j;}
	}
	if(lsa>=13)
	{
		j=0;
		for(i=13;i<lsa;++i){a14[j]=a1[i];++j;}
		for(i=0;i<13;++i){a14[j]=a1[i];++j;}
	}
	if(lsa>=14)
	{
		j=0;
		for(i=14;i<lsa;++i){a15[j]=a1[i];++j;}
		for(i=0;i<14;++i){a15[j]=a1[i];++j;}
	}
	if(lsa>=15)
	{
		j=0;
		for(i=15;i<lsa;++i){a16[j]=a1[i];++j;}
		for(i=0;i<15;++i){a16[j]=a1[i];++j;}
	}
	if(lsa>=16)
	{
		j=0;
		for(i=16;i<lsa;++i){a17[j]=a1[i];++j;}
		for(i=0;i<16;++i){a17[j]=a1[i];++j;}
	}

	if(sf)
	{
		for(i=0;i<15;++i){
		for(j=0;j<15;++j){
		for(k=0;k<15;++k){
		for(l=0;l<15;++l){
			ba16[i][j][k][l][0]=-1;
			ba16[i][j][k][l][1]=0;
		}}}}
		ba16i=0;
	}

	for(i=0;i<lsa;++i)
	{
		b1=0;b2=0;b3=0;b4=0;

		if(a1[i]==a2[i]){b1|=1<<3;}
		if(a1[i]==a3[i]){b1|=1<<2;}
		if(a1[i]==a4[i]){b1|=1<<1;}
		if(a1[i]==a5[i]){b1|=1<<0;}

		if(a1[i]==a6[i]){b2|=1<<3;}
		if(a1[i]==a7[i]){b2|=1<<2;}
		if(a1[i]==a8[i]){b2|=1<<1;}
		if(a1[i]==a9[i]){b2|=1<<0;}

		if(a1[i]==a10[i]){b3|=1<<3;}
		if(a1[i]==a11[i]){b3|=1<<2;}
		if(a1[i]==a12[i]){b3|=1<<1;}
		if(a1[i]==a13[i]){b3|=1<<0;}

		if(a1[i]==a14[i]){b4|=1<<3;}
		if(a1[i]==a15[i]){b4|=1<<2;}
		if(a1[i]==a16[i]){b4|=1<<1;}
		if(a1[i]==a17[i]){b4|=1<<0;}

		if(df){printf("%d %d %d %d\n",b1,b2,b3,b4);}

		if(sf)
		{
			if(ba16[b1][b2][b3][b4][0]==-1)
			{
				ba16[b1][b2][b3][b4][0]=ba16i;++ba16i;
				ba16[b1][b2][b3][b4][1]=1;

			}else{++ba16[b1][b2][b3][b4][1];}
		}else{
			k=0;
			for(l=0;l<hai;++l)
			{
				j=0;
				if(ha[l][0]==b1){++j;++ha[l][5];}
				if(ha[l][1]==b2){++j;++ha[l][5];}
				if(ha[l][2]==b3){++j;++ha[l][5];}
				if(ha[l][3]==b4){++j;++ha[l][5];}
				if(j>=3){++k;}
			}
			if(hc==0){hc=k;}else{if(k>hc){hc=k;}}
		}
	}

	if(df)
	{
		printf("%d %d\n",hai,hc);
		for(i=0;i<15;++i){
		for(j=0;j<15;++j){
		for(k=0;k<15;++k){
		for(l=0;l<15;++l){
			if(ba16[i][j][k][l][0]!=-1)
			{
				printf("!%d %d %d %d %d!\n",i,j,k,l,ba16[i][j][k][l][1]);
			}
		}}}}
	}

	if(sf)
	{
		for(l=0;l<cl;++l){ha[l][0]=0;ha[l][1]=0;ha[l][2]=0;ha[l][3]=0;ha[l][4]=0;ha[l][5]=0;}hai=0;

		for(i=0;i<15;++i){
		for(j=0;j<15;++j){
		for(k=0;k<15;++k){
		for(l=0;l<15;++l){
			if(ba16[i][j][k][l][0]!=-1)
			{
				ha[hai][0]=i;
				ha[hai][1]=j;
				ha[hai][2]=k;
				ha[hai][3]=l;
				ha[hai][4]=ba16[i][j][k][l][1];
				ha[hai][5]=0;
				++hai;
			}
		}}}}
	}
	return(hc);
}

int p_2(char ss_[cl])
{

	int	fbyte,i=0,j,k,l,m,hc=0,bc=0,tc=0;

	if(strlen(infn)>=256){return(0);}
	f1=fopen(infn,"rb");if(f1==NULL){return(0);}//printf("%s %d\n",infn,strlen(infn));
	lac=1;lbc=lac;
	fbyte=getc(f1);
	while(!feof(f1))
	{
		for(i=0;i<cl;++i){sa1[i]='\0';}i=0;
		while((i<cl)&&!feof(f1))
             	{
              		if(fbyte==13||fbyte==10)
             		{
               			while((fbyte==13||fbyte==10)&&!feof(f1)){fbyte=getc(f1);}
               			sa1[i]=(char)10;++i;++lac;
              		}
              		sa1[i]=(char)fbyte;++i;fbyte=getc(f1);
		}
		if(strlen(sa1)>=strlen(ss_))
		{
               		m=0;
			if(strlen(sa1)>=strlen(ss_))
			{
				hc=p_1(sa1,0);
				i=0;++bc;
				if(hc!=0)
				{
					j=0;
					while(j<(strlen(sa1)-strlen(ss_)))
					{
						if(sa1[j]==(char)10){++m;++j;}
						k=0;while((sa1[j+k]==ss_[k])&&j<(strlen(sa1)-strlen(ss_)))
						{++k;if(sa1[j+k]==(char)10){++m;j+=k;break;}}
						if(k==strlen(ss_))
						{
							//printf("\nFile:%s\n",infn);
							printf("Line:%d\t",lbc+m);i=0;
							for(l=j;l<strlen(sa1);++l)
							{
								if(sa1[l]==13||sa1[l]==10){printf("%c%c",(char)13,(char)10);break;}else{
									printf("%c",sa1[l]);++i;
									if(i>=50){printf("%c%c%c%c",(char)13,(char)10,(char)9,(char)9);i=0;}
								}
							}
							if(l==strlen(sa1)){printf("%c%c",(char)13,(char)10);}
							++tc;	
							j+=strlen(ss_);
						}else{++j;}
					}
				}
				lbc+=lac;lac=1;
			}
		}
	}
	fclose(f1);
	return(tc);

}

int main(int argc,char *argv[])
{

	int	a,b,c,ci,d;
	int	i,j,k,l,m;

	char	cmd[50][256];
	char	c_1[256];
	char	c_2[256];

	char	fn[10][2];int	fi=0;
	int	op=0;
	long	pos=0;
	
	int	cc=0;
	int	a1f=0;
	int	a2f=0;
	int	a3f=0;

	char	a1a[cl];
	char	a2a[cl];
	char	a3a[cl];
	int	aia=0;


	printf("\nASCII Text Files Folder Search Routine\n");
	printf("written by Dzinleski Jasenko July , 2012 - March , 2016\n");
	printf("\nOS Win32 VRM 1.5.0\n\n");
	printf("\n");
	
	if(argv[1]==NULL){return(0);}else{
	if(argv[1][0]=='-'&&(argv[1][1]=='h'||argv[1][1]=='l')){}}
	

	for(j=0;j<cl;++j){a1a[j]='\0';a2a[j]='\0';a3a[j]='\0';}
	for(i=0;i<50;++i){for(j=0;j<256;++j){cmd[i][j]='\0';}}
	for(i=0;i<argc;++i){strcpy(cmd[i],argv[i]);}
	//for(j=0;j<i;++j){printf("%s\n",cmd[j]);}//return(0);

	ci=1;
	c_p(c_l,ci,1,c_1);
	c_p(c_1,ci,0,c_2);
	if(c_2[0]<=cmd[1][0]&&cmd[1][0]<=c_2[1])
	{
		if(df){printf("%c\n",cmd[1][0]);}
		ci=2;
		c_p(c_l,ci,1,c_1);
		ci=1;
		c_p(c_1,ci,0,c_2);

		if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
		{
			printf("!Single sentence search\n");
			printf("mGrep4 -s%cSearch string%c -d%c/Folder name%c -xExtension \n",'\"','\"','\"','\"');
			printf("\n");

			return(0);
		}else{
			ci=2;
			c_p(c_1,ci,0,c_2);
			if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
			{
				printf("\tThis source and fast text files folder string search method apply to GNU General Public License.\n");
				printf("\t		Copyright (C) 2001-2016 Jasenko Dzinleski  \n");
				printf("\n");
				printf("\t	This program is free software; you can redistribute it\n");
				printf("\tand/or modify it under the terms of the GNU General Public License as\n");
				printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
				printf("\tLicense, or (at your option) any later version.\n");
				printf("\n");
				printf("\tThis program is distributed in the hope that it will be useful, but\n");
				printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
				printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
				printf("\tGeneral Public License for more details.\n");
				printf("\n");
				printf("\tYou should have received a copy of the GNU General Public License along\n");
				printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
				printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
				printf("\tmGrep4_137 written by Dzinleski Jasenko July , 2012 - March , 2016\n");
				printf("\n");

	 			return(0);

			}else{
				ci=5;
				c_p(c_1,ci,0,c_2);
				if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
				{

				printf("!Single sentence search\n");
				printf("mGrep4 -s%csearch string%c -d%c/folder name/%c -xextension ",'\"','\"','\"','\"');
				printf("\n");

				return(0);


				}
			}
		}

	}else{printf("Error Token %c\n",cmd[1][0]);return(0);}

	ci=1;
	c_p(c_l,ci,1,c_1);
	c_p(c_1,ci,0,c_2);
	if(c_2[0]<=cmd[1][0]&&cmd[1][0]<=c_2[1])
	{
		if(df){printf("%c\n",cmd[1][0]);}
		ci=2;
		c_p(c_l,ci,1,c_1);
		ci=4;
		c_p(c_1,ci,0,c_2);
		if(c_2[0]<=cmd[1][1]&&cmd[1][1]<=c_2[1])
		{
			if(df){printf("%c\n",cmd[1][1]);}
			ci=3;
			c_p(c_l,ci,1,c_1);
			aia=0;
			for(j=2;j<strlen(cmd[1]);++j)
			{
				i=1;
				while(i<=10)
				{
					ci=i;
					c_p(c_1,ci,0,c_2);
					if(c_2[0]<=cmd[1][j]&&cmd[1][j]<=c_2[1]){if(df){printf("%c\n",cmd[1][j]);}if(cmd[1][j]!='\''&&cmd[1][j]!='"'){a1a[aia]=cmd[1][j];++aia;}break;}else{++i;continue;}
					++i;
				}
			}
			if(j==strlen(cmd[1])){a1f=1;}else{printf("Error Parameter %s\n",cmd[1]);return(0);}

		}else{printf("Error Token %c\n",cmd[1][1]);return(0);}

	}else{printf("Error Token %c\n",cmd[1][0]);return(0);}

	if(a1f)
	{

	ci=1;
	c_p(c_l,ci,1,c_1);
	c_p(c_1,ci,0,c_2);
	if(c_2[0]<=cmd[2][0]&&cmd[2][0]<=c_2[1])
	{
		if(df){printf("%c\n",cmd[2][0]);}
		ci=2;
		c_p(c_l,ci,1,c_1);
		ci=6;
		c_p(c_1,ci,0,c_2);
		if(c_2[0]<=cmd[2][1]&&cmd[2][1]<=c_2[1])
		{
			if(df){printf("%c\n",cmd[2][1]);}
			ci=3;
			aia=0;
			c_p(c_l,ci,1,c_1);
			for(j=2;j<strlen(cmd[2]);++j)
			{
				i=1;
				while(i<=14)
				{
					ci=i;
					c_p(c_1,ci,0,c_2);
					if(c_2[0]<=cmd[2][j]&&cmd[2][j]<=c_2[1]){if(df){printf("%c\n",cmd[2][j]);}if(cmd[2][j]!='\''&&cmd[2][j]!='"'){a2a[aia]=cmd[2][j];++aia;}break;}else{++i;continue;}
					++i;
				}
			}
			if(j==strlen(cmd[2])){a2f=1;}else{printf("Error Parameter %s\n",cmd[2]);return(0);}

		}else{printf("Error Token %c\n",cmd[2][1]);return(0);}

	}else{printf("Error Token %c\n",cmd[2][0]);return(0);}

	}else{return(0);}

	if(a2f)
	{

	ci=1;
	c_p(c_l,ci,1,c_1);
	c_p(c_1,ci,0,c_2);
	if(c_2[0]<=cmd[3][0]&&cmd[3][0]<=c_2[1])
	{
		if(df){printf("%c\n",cmd[3][0]);}
		ci=2;
		c_p(c_l,ci,1,c_1);
		ci=7;
		c_p(c_1,ci,0,c_2);
		if(c_2[0]<=cmd[3][1]&&cmd[3][1]<=c_2[1])
		{
			if(df){printf("%c\n",cmd[3][1]);}
			ci=3;
			aia=0;
			c_p(c_l,ci,1,c_1);
			for(j=2;j<strlen(cmd[3]);++j)
			{
				i=1;
				while(i<=14)
				{
					ci=i;
					c_p(c_1,ci,0,c_2);
					if(c_2[0]<=cmd[3][j]&&cmd[3][j]<=c_2[1]){if(df){printf("%c\n",cmd[3][j]);}a3a[aia]=cmd[3][j];++aia;break;}else{++i;continue;}
					++i;
				}
			}
			if(j==strlen(cmd[3])){a3f=1;}else{printf("Error Parameter %s\n",cmd[3]);return(0);}

		}else{printf("Error Token %c\n",cmd[3][1]);return(0);}

	}else{printf("Error Token %c\n",cmd[3][0]);return(0);}

	}else{return(0);}

	if(a3f)
	{

		for(i=0;i<cl;++i){ss[i]='\0';}

		ci=3;
		c_p(c_l,ci,1,c_1);
		ci=9;
		c_p(c_1,ci,0,c_2);
		for(j=0;j<strlen(a1a);++j){if(a1a[j]==c_2[0]){break;}}
		if(j==strlen(a1a))
		{
			ci=10;
			c_p(c_1,ci,0,c_2);
			for(j=0;j<strlen(a1a);++j){if(a1a[j]==c_2[0]){break;}}
			if(j==strlen(a1a))
			{	
				for(j=-1+strlen(a2a);j>=0;--j){if((a2a[j]=='/')||(a2a[j]=='\\')){break;}}
				if(j==-1){printf("Error Token %s\n",cmd[2]);return(0);}
				
				p_d_(a2a,a3a);
				p_1(a2a,1);
				f3=fopen("mls_o2.mar","rb");k=getc(f3);
				while(!feof(f3))
				{
					for(j=0;j<cl;++j){infn[j]='\0';}
					j=0;while(k!=13&&k!=10&&!feof(f3)){infn[j]=k;++j;k=getc(f3);}
					while((k==13||k==10)&&!feof(f3)){k=getc(f3);}
					printf("File :%s \n",infn);
					occ=p_2(a1a);
					if(occ>0){printf("\n\tSearch for :%s \n\tTotal occurences found :%d\n\n",a1a,occ);}
					occ=0;lac=0;lbc=0;
				}
				fclose(f3);
			}
		}
	}

	return(0);

}
